/* gaussjordan4.c                   freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
void gjA()
{
int      i;
fraction  a;
fraction  b;
fraction  c;
fraction  d;
fraction  L1;
fraction  L2;
fraction  det;
fraction  DetA;
fraction  TraceA;
fraction  amnsL1;
fraction  amnsL2;
fraction  DetinvPAP;
fraction  TraceinvPAP;

double pbA    [2][2*TWOCOL];matrix mA     ={2,2*TWOCOL,&pbA    [0][0]};
double pinvPAP[2][2*TWOCOL];matrix minvPAP={2,2*TWOCOL,&pinvPAP[0][0]};
double pbx1   [2][  TWOCOL];matrix mx1    ={2,  TWOCOL,&pbx1   [0][0]};
double pbx2   [2][  TWOCOL];matrix mx2    ={2,  TWOCOL,&pbx2   [0][0]};
double pbAx1  [2][  TWOCOL];matrix mAx1   ={2,  TWOCOL,&pbAx1  [0][0]};
double pbL1x1 [2][  TWOCOL];matrix mL1x1  ={2,  TWOCOL,&pbL1x1 [0][0]};
double pbAx2  [2][  TWOCOL];matrix mAx2   ={2,  TWOCOL,&pbAx2  [0][0]};
double pbL2x2 [2][  TWOCOL];matrix mL2x2  ={2,  TWOCOL,&pbL2x2 [0][0]};
double pbP    [2][2*TWOCOL];matrix mP     ={2,2*TWOCOL,&pbP    [0][0]};
double pbinvP [2][2*TWOCOL];matrix minvP  ={2,2*TWOCOL,&pbinvP [0][0]};
double pbAP   [2][2*TWOCOL];matrix mAP    ={2,2*TWOCOL,&pbAP   [0][0]};
/*-------------------------------- PROGRAM ---------------------------------- */
    a =  rndF(9,1); b =  rndF(9,1); c =  rndF(9,1); d =  subF(addF(a,b),c);

   *(mA.pblock+0  *mA.cols+0) = a.numer; *(mA.pblock+0  *mA.cols+1) = a.denom;
   *(mA.pblock+0  *mA.cols+2) = b.numer; *(mA.pblock+0  *mA.cols+3) = b.denom;
   *(mA.pblock+1  *mA.cols+0) = c.numer; *(mA.pblock+1  *mA.cols+1) = c.denom;
   *(mA.pblock+1  *mA.cols+2) = d.numer; *(mA.pblock+1  *mA.cols+3) = d.denom;

                           L1 = subF(a,c);
                           L2 = addF(a,b);
                       amnsL1 = subF(a,L1);
  *(mx1.pblock+0 *mx1.cols+0) =     -b.numer;
  *(mx1.pblock+0 *mx1.cols+1) =      b.denom;
  *(mx1.pblock+1 *mx1.cols+0) = amnsL1.numer;
  *(mx1.pblock+1 *mx1.cols+1) = amnsL1.denom;

                           L2 = addF(a,b);
                       amnsL2 = subF(a,L2);
  *(mx2.pblock+0 *mx2.cols+0) =     -b.numer;
  *(mx2.pblock+0 *mx2.cols+1) =      b.denom;
  *(mx2.pblock+1 *mx2.cols+0) = amnsL2.numer;
  *(mx2.pblock+1 *mx2.cols+1) = amnsL2.denom;

  do
  {
               rndmI(&mP,3);
          det = detF(&mP);
  }while(!det.numer);

  clrscrn();
  printf("\n                                       The vector x1 :");
  printmI(&mx1);
  printf("\n                              is an eigenvector of A :");
  printmI(&mA);
  printf("\n     corresponding to the eigenvalue L1 = %.0f since :\n",L1.numer);
  printf("\n                                                  Ax :");
   multmF(&mA,&mx1,&mAx1);
  printmI(         &mAx1);
  printf("\n                                              %4.0f x :",L1.numer);
  smultmF(L1,&mx1,&mL1x1);
  printmI(        &mL1x1);
  getchar();

  clrscrn();
  printf("\n                                       The vector x2 :");
  printmI(&mx2);
  printf("\n                         is also an eigenvector of A :");
  printmI(&mA);
  printf("\n     corresponding to the eigenvalue L2 = %.0f since :\n",L2.numer);
  printf("\n                                                  Ax2 :");
  multmF(&mA,&mx2,&mAx2);
  printmI(         &mAx2);
  printf("\n                                              %4.0f x2 :",L2.numer);
  smultmF(L2,&mx2,&mL2x2);
  printmI(        &mL2x2);
  getchar();

  clrscrn();
  printf("                                                               A :");
  printmI(&mA);
  printf("                                                               P :");
  printmI(&mP);
  inverseF(&mP,&minvP);
  printf("                                                            invP :");
  printmF3(&minvP);
  multmF(&mA,&mP,&mAP);
  multmF(&minvP,&mAP,&minvPAP);
  printf("                                                          invPAP :");
  printmF3(&minvPAP);
  getchar();


  clrscrn();
  TraceA = tracemF(&mA);
    DetA =    detF(&mA);
  printf("\n                 The characteristic equation of A is :\n");
  printf("\n                          L**2 - %4.0f L + %4.0f = 0  \n\n",
               TraceA.numer,     DetA.numer);

  TraceinvPAP = tracemF(&minvPAP);
    DetinvPAP =    detF(&minvPAP);
  printf("\n            The characteristic equation of invPAP is :\n");
  printf("\n                          L**2 - %4.0f L + %4.0f = 0  \n\n",
            TraceinvPAP.numer, DetinvPAP.numer);

  printf("\n           A and the invPAP have the same\n");
  printf("\n              characteristic equation         \n");
  printf("\n         also they have the same eigenvalues  \n");
  printf("\n            L1 = %4.0f;   L2 = %4.0f; \n\n",L1.numer,L2.numer);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n\n\n\n\n                                          ");
  printf("\n             A and invPAP have the same    \n");
  printf("\n              characteristic equation           \n");
  printf("\n         also they have the same eigenvalues    \n");
  printf("\n                      *******                   \n");
  printf("\n\n\n\n                                            ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");

  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main()
{
time_t t;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{


  gjA();


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

